// Auto-generated. Do not edit!

// (in-package rc_silhouettematch_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let EstimatedPlane = require('../msg/EstimatedPlane.js');
let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class GetBasePlaneCalibrationRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose_frame = null;
      this.robot_pose = null;
    }
    else {
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('robot_pose')) {
        this.robot_pose = initObj.robot_pose
      }
      else {
        this.robot_pose = new geometry_msgs.msg.Pose();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetBasePlaneCalibrationRequest
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [robot_pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.robot_pose, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetBasePlaneCalibrationRequest
    let len;
    let data = new GetBasePlaneCalibrationRequest(null);
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [robot_pose]
    data.robot_pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.pose_frame.length;
    return length + 60;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_silhouettematch_client/GetBasePlaneCalibrationRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8b3f51f982d04ab801c91dc508875760';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Returns the configured base-plane calibration.
    
    # Required. Pose frame for output poses (valid values are camera and external)
    string pose_frame
    
    # Required only if sensor is robot-mounted
    geometry_msgs/Pose robot_pose
    
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetBasePlaneCalibrationRequest(null);
    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.robot_pose !== undefined) {
      resolved.robot_pose = geometry_msgs.msg.Pose.Resolve(msg.robot_pose)
    }
    else {
      resolved.robot_pose = new geometry_msgs.msg.Pose()
    }

    return resolved;
    }
};

class GetBasePlaneCalibrationResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.plane = null;
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('plane')) {
        this.plane = initObj.plane
      }
      else {
        this.plane = new EstimatedPlane();
      }
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetBasePlaneCalibrationResponse
    // Serialize message field [plane]
    bufferOffset = EstimatedPlane.serialize(obj.plane, buffer, bufferOffset);
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetBasePlaneCalibrationResponse
    let len;
    let data = new GetBasePlaneCalibrationResponse(null);
    // Deserialize message field [plane]
    data.plane = EstimatedPlane.deserialize(buffer, bufferOffset);
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += EstimatedPlane.getMessageSize(object.plane);
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_silhouettematch_client/GetBasePlaneCalibrationResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '62649f685eec6b724723a0f197adb717';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    EstimatedPlane plane
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_silhouettematch_client/EstimatedPlane
    # frame in which normal/offset are given
    string pose_frame
    
    # Normal of the plane. The normal is pointing away from the camera.
    geometry_msgs/Vector3 normal
    
    # Distance of the plane from the origin in normal direction
    float64 distance
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetBasePlaneCalibrationResponse(null);
    if (msg.plane !== undefined) {
      resolved.plane = EstimatedPlane.Resolve(msg.plane)
    }
    else {
      resolved.plane = new EstimatedPlane()
    }

    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: GetBasePlaneCalibrationRequest,
  Response: GetBasePlaneCalibrationResponse,
  md5sum() { return '563eada6119b218faacc850b8b854294'; },
  datatype() { return 'rc_silhouettematch_client/GetBasePlaneCalibration'; }
};
